package com.nisum.omd;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.concurrent.CompletableFuture;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;
import com.fasterxml.jackson.datatype.jsr310.JavaTimeModule;
import com.nisum.omd.domain.Order;
import com.nisum.omd.service.OmdProducerService;
import com.nisum.omd.service.RandomDataGeneratorImpl;

@Component
@RestController
public class OrderGenerator implements CommandLineRunner{

	@Autowired
	RandomDataGeneratorImpl rdg;
	@Autowired
	Order order;

	@Autowired
	OmdProducerService omdProducerService;

	Boolean orderGenerateFlag =  false;
	
	public Boolean getOrderGenerateFlag() {
		return orderGenerateFlag;
	}

	public void setOrderGenerateFlag(Boolean orderGenerateFlag) {
		this.orderGenerateFlag = orderGenerateFlag;
	}
	
	public void run(String... args) throws Exception {
		  while(true) {
			  if (orderGenerateFlag) {
				  order=getObjectData(order);
				  omdProducerService.sendMessage(order);
				  ObjectMapper objectMapper = new ObjectMapper();
				  objectMapper.registerModule(new JavaTimeModule());
				  objectMapper.disable(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS);
				  String jsonOrderStr = objectMapper.writeValueAsString(order);		
				  System.out.println(jsonOrderStr);
				  Thread.sleep(2000);
			  }

		  }
		
	}
	
	 @GetMapping(path="/orderStartStop")
		public String orderStartStop() throws Exception{
		    if (orderGenerateFlag) {
		    	CompletableFuture.runAsync(() -> {
					try {
						run();
					} catch (Exception e) {
						e.printStackTrace();
					}
				});
		    	orderGenerateFlag =  false;
		    	
		    }
		    else {
 		    	orderGenerateFlag = true;

		    }
		    
			return "Order Generate : " + orderGenerateFlag.toString();
		}
	  
	
	public Order getObjectData(Order order2) {
		
		LocalDateTime currentTime = LocalDateTime.now();
    	order.setOrderNum(rdg.generateOrderNumber());
		order.setCustomerId(rdg.generateCustomerId());
		DateTimeFormatter formatter = DateTimeFormatter.ISO_DATE_TIME;
		String formattedDateTime = currentTime.format(formatter);
		order.setOrderDate(formattedDateTime);
		order.setLineItem(rdg.genetateLineItem(order.getLineItem()));
        return order;
	}


}
